//+------------------------------------------------------------------+
//|                                             asymmetric bands.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  5
#property indicator_color1   DimGray
#property indicator_color2   Red
#property indicator_color3   LimeGreen
#property indicator_color4   LimeGreen
#property indicator_color5   Red
#property indicator_style1   STYLE_DOT
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT; // Time frame to use
extern int             bandsPeriod     = 14;             // Bands period
extern ENUM_MA_METHOD  bandsMethod     = MODE_SMA;       // Bands method
extern enPrices        bandsPrice      = 0;              // Price
extern double          bandsDeviations = 2;              // Deviations
extern int             arrowSize       = 2;              // Arrow size
extern bool            alertsOn        = false;          // Turn alert on?
extern bool            alertsOnCurrent = true;           // Alerts on current bar?
extern bool            alertsMessage   = true;           // Alerts should show message?
extern bool            alertsSound     = false;          // Alerts should play a sound
extern bool            alertsNotify    = false;          // Alerts should send notification?
extern bool            alertsEmail     = false;          // Alerts should send an email?
extern bool            Interpolate     = true;           // Interpolate in multi time frame mode?

//
//
//
//
//

double maBuffer[];
double upBuffer[];
double dnBuffer[];
double wuBuffer[];
double wdBuffer[];
double arrowUp[];
double arrowDn[];
double prices[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,maBuffer);
   SetIndexBuffer(1,upBuffer);
   SetIndexBuffer(2,dnBuffer);
   SetIndexBuffer(3,arrowUp); SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,241);
   SetIndexBuffer(4,arrowDn); SetIndexStyle(4,DRAW_ARROW,0,arrowSize); SetIndexArrow(4,242);
   SetIndexBuffer(5,wuBuffer);
   SetIndexBuffer(6,wdBuffer);
   SetIndexBuffer(7,prices);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { maBuffer[0] = MathMin(limit+1,Bars-1); return(0); }
           if (TimeFrame!=_Period)
           {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  int x = iBarShift(NULL,TimeFrame,Time[MathMin(i+1,Bars-1)]);
                     maBuffer[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,bandsPeriod,bandsMethod,bandsPrice,bandsDeviations,arrowSize,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,0,y);
                     upBuffer[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,bandsPeriod,bandsMethod,bandsPrice,bandsDeviations,arrowSize,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,1,y);
                     dnBuffer[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,bandsPeriod,bandsMethod,bandsPrice,bandsDeviations,arrowSize,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,2,y);
                     arrowUp[i]  = EMPTY_VALUE;
                     arrowDn[i]  = EMPTY_VALUE;
                     if (x!=y) 
                     {
                        arrowUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,bandsPeriod,bandsMethod,bandsPrice,bandsDeviations,arrowSize,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,3,y);
                        arrowDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,bandsPeriod,bandsMethod,bandsPrice,bandsDeviations,arrowSize,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,4,y);
                     }
         
                  //
                  //
                  //
                  //
                  //
      
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                  //
                  //
                  //
                  //
                  //

                  int n,k; datetime time = iTime(NULL,TimeFrame,y);
                     for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                     for(k = 1; i+n < Bars && i+k < Bars && k<n; k++)
                     {
                        maBuffer[i+k] = maBuffer[i] + (maBuffer[i+n] - maBuffer[i])*k/n;
                        upBuffer[i+k] = upBuffer[i] + (upBuffer[i+n] - upBuffer[i])*k/n;
                        dnBuffer[i+k] = dnBuffer[i] + (dnBuffer[i+n] - dnBuffer[i])*k/n;
                     }                        
               }
               return(0);
           }

   //
   //
   //
   //
   //
            
   for(int i=limit; i>=0; i--) prices[i] = getPrice(bandsPrice,Open,Close,High,Low,i);
   for(int i=limit; i>=0; i--)
   {
      maBuffer[i] = iMAOnArray(prices,0,bandsPeriod,0,bandsMethod,i);
         if (i==(Bars-1))
         {
            upBuffer[i] = maBuffer[i];
            dnBuffer[i] = maBuffer[i];
            wuBuffer[i] = prices[i]-maBuffer[i];
            wdBuffer[i] = prices[i]-maBuffer[i];
            continue;
         }
         
      //
      //
      //
      //
      //
      
         double diff = prices[i]-maBuffer[i];
         if(diff>=0)
            {
               wuBuffer[i] = (wuBuffer[i+1]*(bandsPeriod-1)+MathPow(diff,2))/bandsPeriod;
               wdBuffer[i] =  wdBuffer[i+1]*(bandsPeriod-1)/bandsPeriod;
            }
         else
            {
               wdBuffer[i] = (wdBuffer[i+1]*(bandsPeriod-1)+MathPow(diff,2))/bandsPeriod;
               wuBuffer[i] =  wuBuffer[i+1]*(bandsPeriod-1)/bandsPeriod;
            }
         upBuffer[i] = maBuffer[i] + bandsDeviations*MathSqrt(wuBuffer[i]);
         dnBuffer[i] = maBuffer[i] - bandsDeviations*MathSqrt(wdBuffer[i]);
         arrowUp[i]  = EMPTY_VALUE;
         arrowDn[i]  = EMPTY_VALUE;
         if (High[i]>=upBuffer[i] && High[i+1]<=upBuffer[i+1]) arrowDn[i] = upBuffer[i] + iATR(NULL,0,20,i)/2.0;
         if ( Low[i]<=dnBuffer[i] &&  Low[i+1]>=dnBuffer[i+1]) arrowUp[i] = dnBuffer[i] - iATR(NULL,0,20,i)/2.0;   
   }

   //
   //
   //
   //
   //
   
      if (alertsOn)
      {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
            if (arrowUp[whichBar+1] == EMPTY_VALUE && arrowUp[whichBar] != EMPTY_VALUE) doAlert(whichBar,"low price crossing lower band");
            if (arrowDn[whichBar+1] == EMPTY_VALUE && arrowDn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"high price crossing upper band");
      }         
   return(0);
}


//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" assymetric bands "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " assymetric bands "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); int r = Bars-i-1; instanceNo*=4;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}